﻿version
6.50
0
Sunandmoon
0
Sub designer
addform(Sunandmoon,"Astro","",220,220,220)@
addimagelist(sunandmoon,moonList,10,215,80,25,29,"moons\m1.jpg","moons\m2.jpg","moons\m3.jpg","moons\m4.jpg","moons\m5.jpg","moons\m6.jpg","moons\m7.jpg","moons\m8.jpg","moons\m9.jpg","moons\m10.jpg","moons\m11.jpg","moons\m12.jpg","moons\m13.jpg","moons\m14.jpg","moons\m15.jpg","moons\m16.jpg","moons\m17.jpg","moons\m18.jpg","moons\m19.jpg","moons\m20.jpg","moons\m21.jpg","moons\m22.jpg","moons\m23.jpg","moons\m24.jpg","moons\m25.jpg","moons\m26.jpg","moons\m27.jpg","moons\m28.jpg","moons\m29.jpg",0)@
addimage(sunandmoon,Mimg,165,100,60,60,"cCenterImage","",220,220,220,True,True)@
addlabel(sunandmoon,Label9,20,170,45,25,"Phase",220,220,220,0,0,0,True,True,9)@
addtextbox(sunandmoon,MoonPhase,75,165,25,22,"",255,255,255,0,0,0,True,True,False,9)@
addlabel(sunandmoon,Label8,5,135,65,23,"Moon Set",220,220,220,0,0,0,True,True,9)@
addlabel(sunandmoon,Label7,5,110,70,25,"Moon Rise",220,220,220,0,0,0,True,True,9)@
addtextbox(sunandmoon,moonset,75,135,50,22,"",255,255,255,0,0,0,True,True,False,9)@
addtextbox(sunandmoon,moonrise,75,110,50,22,"",255,255,255,0,0,0,True,True,False,9)@
addlabel(sunandmoon,Label6,110,15,20,25,"Y",220,220,220,0,0,0,True,True,9)@
addlabel(sunandmoon,Label5,60,15,20,25,"M",220,220,220,0,0,0,True,True,9)@
addlabel(sunandmoon,Label4,10,15,20,25,"D",220,220,220,0,0,0,True,True,9)@
addtextbox(sunandmoon,day,30,15,25,22,"",255,255,255,0,0,0,True,True,False,9)@
addtextbox(sunandmoon,month,80,15,25,22,"",255,255,255,0,0,0,True,True,False,9)@
addtextbox(sunandmoon,year,130,15,40,22,"",255,255,255,0,0,0,True,True,False,9)@
addlabel(sunandmoon,Label3,5,75,55,25,"Sun Set",220,220,220,0,0,0,True,True,9)@
addlabel(sunandmoon,Label2,5,50,55,25,"Sun Rise",220,220,220,0,0,0,True,True,9)@
addlabel(sunandmoon,Label1,180,15,20,25,"TZ",220,220,220,0,0,0,True,True,9)@
addtextbox(sunandmoon,Delta,200,15,35,22,"",255,255,255,0,0,0,True,True,False,9)@
addtextbox(sunandmoon,sunset,65,75,50,22,"",255,255,255,0,0,0,True,True,False,9)@
addtextbox(sunandmoon,sunrise,65,50,50,22,"",255,255,255,0,0,0,True,True,False,9)@
addbutton(sunandmoon,sunmoon,155,50,75,23,"Calculate",128,255,128,0,0,0,True,True,9)@
addmenuitem(sunandmoon,back,"Close",True,False)@
End Sub
@EndOfDesignText@
' put these subs  and definitions in the main module:

'Sub toAstro_Click
'astro.return_name = "main.back_from_astro"
'ttmp = main.gpsd.Time   ' gpsd is an object of GPSDriver.DLL
'astro.stryear = DateYear(ttmp)
'astro.strmonth = DateMonth(ttmp)
'astro.strday = DateDay(ttmp)
'If gpsd.Latitude <> gpsd.InvalidData then 
'   astro.latlong.lat = gpsd.Latitude
'   astro.latlong.long = gpsd.Longitude
'   astro.init
'end if
'End Sub
'
'Public Sub back_from_astro
'form1.Show
'End Sub


Sub Globals

	Public Type(lat,long)latlong
	Dim date_split(0)
	Dim Ma(4,4)
	DToR = cPI/180
	R1= DtoR
	
	Public strday 
	Public strmonth 
	Public stryear 
	
	Dim F,T,L5,Z0,M8,W8,A2,A0,D2,D0,V0,V2,J,A5,D5,R5,S,C,Z,T0,C0	
	P2 = 2*cPI
	K1=15*R1*1.0027379

	Public return_name 
End Sub

#Region initialization
Public Sub init
DateFormat ("dd.mm.yyyy")
day.Text = strday
month.Text = strmonth
year.Text = stryear
delta.Text = main.delta_hour
Sunandmoon.Show
End Sub

Sub astro_close
CallSub(return_name)
End Sub

Sub back_Click
CallSub(return_name)
End Sub

Sub sunmoon_Click
sunrise.Text = ""
sunset.Text = ""
moonrise.Text = ""
moonset.Text = ""
sun
moon
phase
End Sub
#End Region

#Region sunrise and sunset
Sub sun
' enabling change of dates on the form.
strday=day.Text  
strmonth = month.Text  
stryear = year.Text  
			'calculate days since 2000 jan 1
  d = ( 367 * strYear - Int((7 * (strYear + ((strMonth + 9) / 12))) / 4) + Int((275 * strMonth) / 9) + strDay - 730530)

' Orbital elements of the Sun:

  w = 282.9404 + 4.70935E-5 * d
  e = 0.016709 - 1.151E-9 * d
  M = 356.0470 + 0.9856002585 * d
  M = rev(M)

  ecl = 23.4393 - 3.563E-7 * d
  L = w + M
  If (L < 0 OR L > 360) Then
    L = rev(L)
  End If
 
  ' position of the Sun

  E1 = M + e/dtor * Sin(M*dtor) * ( 1.0 + e * Cos(M*dtor) )
  xv = Cos(E1*dtor) - e
  yv = ZSqrt(1.0 - e * e) * Sin(E1*dtor)

  v = ATan2(yv, xv)/dtor
  r = zSqrt(xv * xv + yv * yv) 
  lonsun = v + w
  If (lonsun < 0 OR lonsun > 360) Then
    lonsun = rev(lonsun)
  End If
  xs = r * Cos(dtor*lonsun)
  ys = r * Sin(dtor*lonsun)
  xe = xs
  ye = ys * Cos(dtor*ecl)
  ze = ys * Sin(dtor*ecl)
  RA = ATan2(ye, xe)/dtor
  Dec = ATan2(ze, ZSqrt(xe * xe + ye * ye))/dtor
  h = -0.833
  GMST0 = L + 180
  If GMST0 < 0 OR GMST0 > 360 Then
    GMST0 = rev(GMST0)
  End If

  UT_Sun = ( RA - GMST0 - latlong.long ) / 15
  If UT_Sun < 0 Then
    UT_Sun = UT_Sun + 24
  End If

  LHA = (Sin(dtor*h) - (Sin(dtor*latlong.lat) * Sin(dtor*Dec)))/(Cos(dtor*latlong.lat) * Cos(dtor*Dec))
  If LHA > -1 AND LHA < 1 Then
    LHA = ACos(LHA)/dtor/15
  Else 
    sunrise.Text = "Error"
    Return 
  End If 
  hour_rise = UT_Sun - LHA
  hour_set = UT_Sun + LHA
  
  min_rise = Int((hour_rise-Int(hour_rise)) * 60)
  min_set = Int((hour_set-Int(hour_set)) * 60)
  
  hour_rise = (Int(hour_rise)+ main.delta_hour + 24) Mod(24)
  hour_set = (Int(hour_set)+ main.delta_hour + 24)Mod(24) 
  
  hr = Min(hour_rise,hour_set)
  hs = Max(hour_rise,hour_set)

  sunrise.Text = Format(hr,"D2") & ":" & Format(min_rise,"D2")
  sunset.text = Format(hs,"D2") & ":" & Format(min_set,"D2")

  Return
End Sub

Sub rev(qqq) 
 x = (qqq - Int(qqq/360) * 360)
 Do While (x <= 0) 
  x = x + 360
 Loop
 Return x
End Sub

Sub ATan2(x,y)
 If y = 0 Then
   If x>0 Then
     a = cPI/2
   Else If x<0 Then
     a = -cPI/2
   Else
     a=0
   End If
 Else
   a=ATan(x/y)
   If x<0 AND y>0 Then
     a = cPI + a
   Else If x<0 AND y<0 Then
     a = -cPI + a
   End If
 End If
 Return a
End Sub

Sub ZSqrt(x)
 If x > 0 Then
  r = Sqrt(x)
 Else
  r = 0
 End If
 Return r
End Sub
#End Region

#Region moon rise and set
Sub moon
B5 = latlong.lat
L5 = latlong.long
L5 = L5/360
Z0 = -main.delta_hour/24
X760
T=(J-2451545)+F
X245                         ' sub names follow the original code
T=T+Z0

		'      POSITION Loop
For I=1 To 3
	X495
	Ma(I,1)=A5
	Ma(I,2)=D5
	Ma(I,3)=R5
	T=T+0.5
Next
If Ma(2,1)<= Ma(1,1) Then 
   Ma(2,1)=Ma(2,1)+P2
End If
If Ma(3,1) <= Ma(2,1) Then 
   Ma(3,1)=Ma(3,1)+P2
End If
Z1=R1*(90.567-41.685/Ma(2,3))
S=Sin(B5*R1)  
C=Cos(B5*R1)
Z=Cos(Z1)

A0=Ma(1,1)
D0=Ma(1,2)

For C0=0 To 23
	P=(C0+1)/24
	F0=Ma(1,1)
	F1=Ma(2,1)
	F2=Ma(3,1)
	
	A=F1-F0
	B=F2-F1-A
	A2=F0+P*(2*A+B*(2*P-1))
	F0=Ma(1,2)
	F1=Ma(2,2)
	F2=Ma(3,2)
	A=F1-F0
	B=F2-F1-A
	D2=F0+P*(2*A+B*(2*P-1))
	
	x285
	A0=A2
	D0=D2
	V0=V2
Next
x450  ' REM  SPECIAL MSG?
End Sub


Sub x760
                         '      CALENDAR --> JD
							' Get current Date 
D = day.Text 
Mo = month.Text
Y = year.Text 

G=1
If Y<1582 Then G=0
D1=Int(D)
F=D-D1-0.5
J = -Int(7*(Int((Mo+9)/12)+Y)/4)
If G<>0 Then
   If Mo <> 9 Then
     A = Abs(Mo-9)
     S = (Mo-9)/A
	 J3 = Int(Y+S*Int(A/7))
   Else
     j3 = Int(y)
   End If
   j3 = Int(j3/100)
   J3 = -Int((j3 +1)* 3 / 4)
End If
J=J+Int(275*Mo/9)+D1+G*J3
J=J+1721027+2*G+367*Y
If F>=0 Then Return
F=F+1
J=J-1
Return
End Sub

Sub x495
			'   FUNDAMENTAL ARGUMENTS
L=0.606434+0.03660110129*T
M=0.374897+0.03629164709*T
F=0.259091+0.03674819520*T
D=0.827362+0.03386319198*T
N=0.347343-0.00014709391*T
G=0.993126+0.00273777850*T
L=L-Int(L)
M=M-Int(M)
F=F-Int(F)
D=D-Int(D)
N=N-Int(N)
G=G-Int(G)
L=L*P2
M=M*P2
F=F*P2
D=D*P2
N=N*P2
G=G*P2
V=0.39558*Sin(F+N)
V=V+0.08200*Sin(F)
V=V+0.03257*Sin(M-F-N)
V=V+0.01092*Sin(M+F+N)
V=V+0.00666*Sin(M-F)
V=V-0.00644*Sin(M+F-2*D+N)
V=V-0.00331*Sin(F-2*D+N)
V=V-0.00304*Sin(F-2*D)
V=V-0.00240*Sin(M-F-2*D-N)
V=V+0.00226*Sin(M+F)
V=V-0.00108*Sin(M+F-2*D)
V=V-0.00079*Sin(F-N)
V=V+0.00078*Sin(F+2*D+N)
U=1-0.10828*Cos(M)
U=U-0.01880*Cos(M-2*D)
U=U-0.01479*Cos(2*D)
U=U+0.00181*Cos(2*M-2*D)
U=U-0.00147*Cos(2*M)
U=U-0.00105*Cos(2*D-G)
U=U-0.00075*Cos(M-2*D+G)
W=0.10478*Sin(M)
W=W-0.04105*Sin(2*F+2*N)
W=W-0.02130*Sin(M-2*D)
W=W-0.01779*Sin(2*F+N)
W=W+0.01774*Sin(N)
W=W+0.00987*Sin(2*D)
W=W-0.00338*Sin(M-2*F-2*N)
W=W-0.00309*Sin(G)
W=W-0.00190*Sin(2*F)
W=W-0.00144*Sin(M+N)
W=W-0.00144*Sin(M-2*F-N)
W=W-0.00113*Sin(M+2*F+2*N)
W=W-0.00094*Sin(M-2*D+G)
W=W-0.00092*Sin(2*M-2*D)

			'  COMPUTE RA, DEC, DIST
S=W/Sqrt(U-V*V)
A5=L+ATan(S/Sqrt(1-S*S))
S=V/Sqrt(U)
D5=ATan(S/Sqrt(1-S*S))
R5=60.40974*Sqrt(U)
Return
End Sub


Sub X285
   '  TEST AN HOUR For AN EVENT
L0=T0+C0*K1
L2=L0+K1
If A2<A0 Then A2=A2+P2
H0=L0-A0
H2=L2-A2
H1=(H2+H0)/2          '  REM  HOUR ANGLE
D1=(D2+D0)/2            ' REM  DEC
If C0<=0 Then 
    V0=S*Sin(D0)+C*Cos(D0)*Cos(H0)-Z
End If
V2= S *Sin(D2)+C*Cos(D2)*Cos(H2)-Z
If V0/Abs(V0)=V2/Abs(V2) Then Return
V1= S *Sin(D1)+C*Cos(D1)*Cos(H1)-Z
A=2*V2-4*V1+2*V0
B=4*V1-3*V0-V2
D=B*B-4*A*V0
If D<0 Then Return
D=Sqrt(D)
If V0<0 AND V2>0 Then M8=1
If V0>0 AND V2<0 Then W8=1
E=(-B+D)/(2*A)
If E>1 OR E<0 Then E=(-B-D)/(2*A)
T3=C0+E+1/120              '  REM Round OFF
H3=Int(T3)
M3=Int((T3-H3)*60)
If V0<0 AND V2>0 Then moonrise.text = disp(H3,M3)
If V0>0 AND V2<0 Then moonset.text = disp(H3,M3)
'PRINT USING "##:##";H3;M3;
   ' calculate the azimuth
'H7=H0+E*(H2-H0)
'N7=-Cos(D1)*Sin(H7)
'D7=C*Sin(D1)-S*Cos(D1)*Cos(H7)
'A7=ATan(N7/D7)/R1
'If D7<0 Then A7=A7+180
'If A7<0 Then A7=A7+360
'If A7>360 Then A7=A7-360
Return
End Sub

Sub disp(Hours,minutes)
st = Format(hours,"D2")  & ":" & Format(minutes,"D2")
Return st
End Sub

Sub x450
					'   SPECIAL MESSAGE ROUTINE
If M8=0 AND W8=0 Then 
 If V2<0 Then Msgbox("MOON DOWN ALL DAY")
 If V2>0 Then Msgbox("MOON UP ALL DAY")
Else
 If M8=0 Then Msgbox("NO MOONRISE THIS DATE")
 If W8=0 Then Msgbox("NO MOONSET THIS DATE")
End If
Return
End Sub

Sub x245
					'   LST AT 0H ZONE Time
T0=T/36525
S=24110.5+8640184.813*T0
S=S+86636.6*Z0+86400*L5
S=S/86400
S=S-Int(S)
T0=S*360*R1
Return
End Sub
#End Region

#Region moon phase
Sub phase
ErrorLabel(founderror)
nYearH = year.Text 
nmonthH = month.Text
ndateH = day.Text 
dgreg = Format(ndateH,"d2") &"." & Format(nmonthH,"D2") & "." & Format(nyearH,"D4")
Heb_day_of_month = GregToHeb(dgreg,nYearH,nMonthH,nDateH) 
moonphase.Text = Heb_day_of_month
mimg.Image = moonlist.Item(Heb_day_of_month-1)
'mimg.Image = moonlist.Item(0)
Return 1
founderror:
'Msgbox("Date unknown")
'Return 0
Return 1  ' temporary
End Sub

Sub GregToHeb(dGreg,nYearH,nMonthH,nDateH)
nOneMolad = 29 + (12 / 24) + (793 / (1080 * 24))
nAvrgYear = nOneMolad * (235 / 19)
low = Date(DateParse("01.01.1900"))
ndays =  DaysBetweenDates(dgreg,low)
nDays = nDays + 2067025 ' 2067025 days after creation
nYearH = Int(nDays / nAvrgYear) + 1 
dTishrei1 = Tishrei1(nYearH)
If dTishrei1 = dGreg Then
    nMonthH = 1
    nDateH = 1
Else
    If DateParse(dTishrei1) < DateParse(dGreg) Then
        Do While DateParse(Tishrei1(nYearH + 1)) <= DateParse(dGreg)
           nYearH = nYearH + 1
        Loop
    Else
        nYearH = nYearH - 1
        Do While DateParse(Tishrei1(nYearH)) > DateParse(dGreg)
           nYearH = nYearH - 1
        Loop
    End If

    ndays = DaysBetweenDates(dgreg, Tishrei1(nYearH))
    nLengthOfYear = LengthOfYear(nYearH)
    If nLengthOfYear = 353 OR nLengthOfYear = 383 Then bHaser = True Else bHaser = False
    If nLengthOfYear = 355 OR nLengthOfYear = 385 Then bShalem = True Else bShalem = False
	bLeap = IsLeapYear(nYearH)
    nMonthH = 1
    Do
       Select nMonthH
          Case 1, 5, 8, 10, 12 ' 30 day months
            nMonthLen = 30
          Case 4, 7, 9, 11, 13 ' 29 day months
            nMonthLen = 29
          Case 6 ' Adar A (6) will be skipped on non-leap years
            nMonthLen = 30
          Case 2 ' Cheshvan, see note above
             If bShalem Then nMonthLen =  30 Else nMonthLen =  29
          Case 3 ' Kislev, see note above
             If bHaser Then nMonthLen =  29 Else nMonthLen =  30
       End Select
       If nDays >= nMonthLen Then
          bWhile = True
          If bLeap OR nMonthH <> 5 Then
            nMonthH = nMonthH + 1
          Else
             nMonthH = nMonthH + 2
          End If
          nDays = nDays - nMonthLen
       Else
          bWhile = False
       End If
    Loop While bWhile = True
    nDateH = nDays + 1
End If
Return nDateH
End Sub

Sub DaysBetweenDates(late,early)
If DateParse(early) > DateParse(late) Then
   temp = early
   early = late
   late = temp
   s = -1
Else
   s=1
End If
date_split() = StrSplit(early,".")
startyear = date_split(2)
days = 0
date_split() = StrSplit(late,".")
year = date_split(2) - 1 
For i = startyear To year 
   days = days + DateDayOfYear (DateParse("31.12." & i))
Next
days = days + DateDayOfYear (DateParse(late)) - DateDayOfYear(DateParse(early))
Return days * s
End Sub
  

Sub Tishrei1(nYearH) 
nMonthsSinceFirstMolad = MonSinceFirstMolad(nYearH)
nChalakim = 793 * nMonthsSinceFirstMolad
nChalakim = nChalakim + 204
nHours = Int(nChalakim / 1080)
nChalakim = nChalakim Mod 1080

nHours = nHours + nMonthsSinceFirstMolad * 12
nHours = nHours + 5
    
nDays = Int(nHours / 24)
nHours = nHours Mod 24

nDays = nDays + 29 * nMonthsSinceFirstMolad
nDays = nDays + 2

nDayOfWeek = nDays Mod 7

If Not(IsLeapYear(nYearH)) AND  nDayOfWeek = 3 AND (nHours * 1080) + nChalakim >= (9 * 1080) + 204 Then
   nDayOfWeek = 5
   nDays = nDays+ 2
Else
   If IsLeapYear(nYearH - 1) AND nDayOfWeek = 2 AND (nHours * 1080) + nChalakim >= (15 * 1080) + 589 Then
      nDayOfWeek = 3
      nDays = nDays + 1
   Else
      If nHours >= 18 Then
          nDayOfWeek = nDayOfWeek + 1
          nDayOfWeek = nDayOfWeek Mod 7
          nDays = nDays + 1
      End If
      If nDayOfWeek = 1 OR nDayOfWeek = 4 OR nDayOfWeek = 6 Then
          nDayOfWeek = nDayOfWeek + 1
          nDayOfWeek = nDayOfWeek Mod 7
          nDays = nDays + 1
      End If
   End If
End If
nDays = nDays - 2067025
t = DateParse ("01.01.1900")
dTishrei1 =StrReplace( Date(DateAdd(t,0,0,nDays)),"/",".")
Return dTishrei1
End Sub

Sub LengthOfYear(nYearH ) 
dThisTishrei1 = Tishrei1(nYearH)
dNextTishrei1 = Tishrei1(nYearH + 1)
a = DateDayOfYear (DateParse(dThisTishrei1))
b = DateDayOfYear (DateParse(dnextTishrei1))
diff = b-a
If diff < 353 Then 
   date_split() = StrSplit(dThisTishrei1,".")
   c = DateDayOfYear (DateParse ("31.12." & date_split(2)))
   diff = diff + c
End If
Return diff
End Sub

Sub IsLeapYear(nYearH )
nYearInCycle = Int(nYearH Mod 19)
If nYearInCycle = 0 OR nYearInCycle = 3 OR nYearInCycle = 6  OR nYearInCycle = 8 OR nYearInCycle = 11 OR nYearInCycle = 14 OR nYearInCycle = 17 Then
  Return True
Else
  Return False
End If
End Sub

Sub MonSinceFirstMolad(nYearH)  
nYearH  = nYearH - 1
nMonSinceFirstMolad = Int(nYearH / 19) * 235
nYearH = nYearH Mod 19
nMonSinceFirstMolad = nMonSinceFirstMolad + 12 * nYearH
If nYearH >= 17 Then
  nMonSinceFirstMolad = nMonSinceFirstMolad + 6
Else
  If nYearH >= 14 Then
    nMonSinceFirstMolad = nMonSinceFirstMolad + 5
  Else
    If nYearH >= 11 Then
      nMonSinceFirstMolad = nMonSinceFirstMolad + 4
    Else
      If nYearH >= 8 Then
        nMonSinceFirstMolad = nMonSinceFirstMolad + 3
      Else
	    If nYearH >= 6 Then
          nMonSinceFirstMolad = nMonSinceFirstMolad + 2
        Else
		  If nYearH >= 3 Then
            nMonSinceFirstMolad = nMonSinceFirstMolad + 1
          End If
    	End If
	  End If
	End If
  End If
End If
Return nMonSinceFirstMolad
End Sub

'alternative, shorter and less accurate algorithm

'Sub phase(year,month,day) 
'	n = Int(12.37 * (year -1900 + ((1.0 * month - 0.5)/12.0)))
'	t = n / 1236.85
'	t2 = t * t
'	Ams = 359.2242 + 29.105356 * n
'	am = 306.0253 + 385.816918 * n + 0.010730 * t2
'	xtra = 0.75933 + 1.53058868 * n + ((1.178e-4) - (1.55e-7) * t) * t2
'	xtra = xtra + (0.1734 - 3.93e-4 * t) * Sin(dtor * Ams) - 0.4068 * Sin(dtor * am)
'	'i = (xtra > 0.0 ? Int(xtra) :  Math.ceil(xtra - 1.0));  ??????????????????
'	i = Round(xtra) ' ??????????????????
'	jx = j + 1 'julday(year,month,day)  j is calculated at the moon sub
'	jd = (2415020 + 28 * n) + i
'	jul.Text =  (jx-jd + 30)Mod(30)
'End Sub

'
'
'Sub julday(year, month, day) 
'	If (year < 0) Then  year = year + 1
'	jy = year
'	jm = month +1
'	If month <= 2 Then
'	   jy = jy-1
'	   jm = jm + 12
'	End If
'	jul = Int(365.25 *jy) + Int(30.6001 * jm) + day + 1720995
'	If (day+31*(month+12*year) >= (15+31*(10+12*1582))) Then
'		ja = Int(0.01 * jy)
'		jul = jul + 2 - ja + Int(0.25 * ja)
'	End If
'	Return jul
'End Sub
#End Region

